#include <stdio.h>
#include <unistd.h>
#include "uti.h"
#include "sun.h"

static SUNHDR sunHdr;


int InitSun ( int audio, long channels, unsigned long rate, long nBitsPerSample,
	     unsigned long expected_bytes)
{
  sunHdr.magic         = 0x646e732e;
  sunHdr.data_location = 0x20;
  sunHdr.size          = expected_bytes;
  sunHdr.format        = nBitsPerSample > 8 ? 0x03 : 0x02;
  sunHdr.sample_rate   = rate;
  sunHdr.channelcount  = channels;

  return write (audio, &sunHdr, sizeof (sunHdr));
}

int ExitSun ( int audio, unsigned long nBytesDone )
{
  sunHdr.size = nBytesDone;

  /* goto beginning */
  if (lseek(audio, 0L, SEEK_SET) == -1) {
    return 0;
  }
  return write (audio, &sunHdr, sizeof (sunHdr));
}

unsigned long GetSunHdrSize( void )
{
  return sizeof( sunHdr );
}
