#include <stdio.h>
#include <unistd.h>
#include "uti.h"
#include "wav.h"

static WAVEHDR waveHdr;

int InitWav ( int audio, long channels, unsigned long rate, long nBitsPerSample,
	     unsigned long expected_bytes)
{
  waveHdr.chkRiff.ckid    = FOURCC_RIFF;
  waveHdr.fccWave         = FOURCC_WAVE;
  waveHdr.chkFmt.ckid     = FOURCC_FMT;
  waveHdr.chkFmt.dwSize   = sizeof (PCMWAVEFORMAT);
  waveHdr.wFormatTag      = WAVE_FORMAT_PCM;
  waveHdr.nChannels       = channels;
  waveHdr.nSamplesPerSec  = rate;
  waveHdr.nBlockAlign     = channels * ((nBitsPerSample + 7) / 8);
  waveHdr.nAvgBytesPerSec = waveHdr.nBlockAlign * waveHdr.nSamplesPerSec;
  waveHdr.wBitsPerSample  = nBitsPerSample;
  waveHdr.chkData.ckid    = FOURCC_DATA;
  waveHdr.chkRiff.dwSize  = expected_bytes + sizeof(WAVEHDR) - sizeof(CHUNKHDR) ;
  waveHdr.chkData.dwSize  = expected_bytes;

  return write (audio, &waveHdr, sizeof (waveHdr));
}

int ExitWav ( int audio, unsigned long nBytesDone )
{
  waveHdr.chkRiff.dwSize = nBytesDone + sizeof(WAVEHDR) - sizeof(CHUNKHDR) ;
  waveHdr.chkData.dwSize = nBytesDone;

  /* goto beginning */
  if (lseek(audio, 0L, SEEK_SET) == -1) {
    return 0;
  }
  return write (audio, &waveHdr, sizeof (waveHdr));
}

unsigned long GetWavHdrSize( void )
{
  return sizeof( waveHdr );
}
